<?
// +-----------------------------------------------------------------+
// | AGATA Report                                                    |
// | Copyleft (l) 2002  UNIVATES Lajeado/RS - Brasil                 |
// +-----------------------------------------------------------------+
// | Licensed under GPL: www.fsf.org for further details             |
// |                                                                 |
// | Site:   http://agata.codigoaberto.org.br                        |
// +-----------------------------------------------------------------+
// | Abstract: Graphical tool, written in PHP-GTK that allows        |
// |       to edit and getting SQL results from PostgreSQL Database. |
// |                                                                 |
// | Created at August, 10, 2001                                     |
// | Created by Pablo Dall'Oglio  (pablo@univates.br, pablo@php.net) |
// +-----------------------------------------------------------------+


class MainModule extends AgataCore
{
  var $Grade;
  var $book_open = null;
  var $book_open_mask = null;
  var $book_closed = null;
  var $book_closed_mask = null;
  var $AgataNotebook = null;
  var $window;
  var $LivroAberto;
  var $LivroFechado;

  var $Blocks;
  var $Tables;

  var $TableList;
  var $TableListRows;

  var $FieldList;
  var $FieldListRows;

  var $SelectList;
  var $SelectListRows;

  var $NumeroDaObra;
  var $CodigoDoExemplar;
  var $Grade;
  
  var $ReportFile;

  /***********************************************************/
  /* Funo que verifica tecla pressionada
  /***********************************************************/
  function KeyTest($p1, $p2)
  {
    if ($p1->keyval == 65307)
       $this->FechaJanela();

/*    $Funcionalidades['Reserva'][65535] = '$this->RemoveDaLista();';
    $Funcionalidades['Pessoa'][65293] = '$this->ExibeNome();';
    $Funcionalidades['Nome'][65293] = '$this->BuscaPessoasPorNome();';
    $Funcionalidades['Obra'][65293] = '$this->VerificaObra();';
    $Funcionalidades['Exemplar'][65293] = '$this->VerificaExemplar();';

    if (count($Funcionalidades[$p2])>0)
      eval ($Funcionalidades[$p2][$p1->keyval]);*/
  }

  /***********************************************************/
  /* Funo que fecha janela de reserva
  /***********************************************************/
  function FechaJanela()
  {
    $this->window->hide();
  }

  /***********************************************************/
  /* Mtodo construtor da janela de Reservas
  /***********************************************************/
  function MainModule($aAgataConfig, $aDescription)
  {
    include ('book.def');
    $this->InicializaVars();
    $this->LivroAberto  = $LivroAberto;
    $this->LivroFechado = $LivroFechado;
    $this->aAgataConfig = $aAgataConfig;
    $this->aDescription = $aDescription;

    $this->window = new GtkWindow;
    $this->window->connect_object('delete_event', array(&$this, 'FechaJanela'));
    $this->window->set_title('Agata Report');
    $this->window->set_border_width(0);
    $this->window->set_default_size(640, 520);
    $this->window->set_position(GTK_WIN_POS_CENTER);
    $this->window->set_policy(false, false, false);
    $this->tooltips = &new GtkTooltips();

    $this->window->add_events(GDK_KEY_PRESS_MASK);
    $this->window->connect_object('key_press_event', array(&$this,'KeyTest'), 'Agata');
    $this->window->realize();

    $Vbox = &new GtkVBox(false, 2);
    $this->window->add($Vbox);

    $box = &new GtkHBox(false, 4);
    $Vbox->pack_start($box);
    
    $MenuBar = &new GtkMenuBar;
    if (strtoupper(substr(PHP_OS, 0, 3)) != 'WIN')
      $box->pack_start($MenuBar);

    
    $Menu = &new GtkMenu;

    $MenuP1 = &new GtkMenuItem(Trans::Translate('File'));
    $MenuP2 = &new GtkMenuItem(Trans::Translate('Run'));
    $MenuP3 = &new GtkMenuItem(Trans::Translate('Tools'));
    $MenuP4 = &new GtkMenuItem(Trans::Translate('Import'));
    $MenuP5 = &new GtkMenuItem(Trans::Translate('?'));

      $SubP1 = &new GtkMenu;
      $MenuP1->set_submenu($SubP1);
      
      $MenuP1I1 = &new GtkMenuItem(Trans::Translate('Clear Query'));
      $MenuP1I1->connect_object('activate', array(&$this,'ClearQuery'));

      $MenuP1I2 = &new GtkMenuItem(Trans::Translate('Open SQL File'));
      $MenuP1I2->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Open SQL File'), true, 'OpenSQLFile', 'You Have to build the SQL Query firstly', '*.sql');

      $MenuP1I3 = &new GtkMenuItem(Trans::Translate('Save to SQL File'));
      $MenuP1I3->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Save to SQL File'), '$this->ReturnSQL()', 'SaveSQLFile', 'You Have to build the SQL Query firstly', '*.sql');
      
      $MenuP1I4 = &new GtkMenuItem(Trans::Translate('Configuration'));
      $MenuP1I4->connect_object('activate', array(&$this,'AgataConfig'));
      
      $SubP1->append($MenuP1I1);
      $SubP1->append($MenuP1I2);
      $SubP1->append($MenuP1I3);
      $SubP1->append($MenuP1I4);
    
      $SubP2 = &new GtkMenu;
      $MenuP2->set_submenu($SubP2);
      
      $MenuP2I1 = &new GtkMenuItem(Trans::Translate('Execute Query'));
      $MenuP2I1->connect_object('activate', array(&$this,'QueryOnScreen'));
      
      $MenuP2I2 = &new GtkMenuItem(Trans::Translate('Save to TXT File'));
      $MenuP2I2->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Save to TXT File'), '$this->ReturnSQL()', 'SaveTXTFile', 'You Have to build the SQL Query firstly', '*.txt');
      
      $MenuP2I3 = &new GtkMenuItem(Trans::Translate('Save to PS File'));
      $MenuP2I3->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Save to PS File'), '$this->ReturnSQL()', 'SavePSFile', 'You Have to build the SQL Query firstly', '*.ps');
      
      $SubP2->append($MenuP2I1);
      $SubP2->append($MenuP2I2);
      $SubP2->append($MenuP2I3);
      
      $SubP3 = &new GtkMenu;
      $MenuP3->set_submenu($SubP3);

      $MenuP3I1 = &new GtkMenuItem(Trans::Translate('Merge with Doc'));
      $MenuP3I1->connect_object('activate', array(&$this,'Merge'), Trans::Translate('Merge with Doc'), '$this->ReturnSQL()', '', 'You Have to build the SQL Query firstly', '');

      $MenuP3I2 = &new GtkMenuItem(Trans::Translate('Label Tool'));
      $MenuP3I2->connect_object('activate', array(&$this,'Label'), Trans::Translate('Label Tool'), '$this->ReturnSQL()', '', 'You Have to build the SQL Query firstly', '');

      $MenuP3I3 = &new GtkMenuItem(Trans::Translate('Create Diagram'));
      $MenuP3I3->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Create Diagram'), '($this->Block[\'From\'][1])', 'CreateDia', 'Require Tables, please', '*.dia');
      
      $MenuP3I4 = &new GtkMenuItem(Trans::Translate('Generate Graphic'));
      $MenuP3I4->connect_object('activate', array(&$this,'Graph'), Trans::Translate('Generate Graphic'), true, '', '');

      $SubP3->append($MenuP3I1);
      $SubP3->append($MenuP3I2);
      $SubP3->append($MenuP3I3);
      
      $SubP4 = &new GtkMenu;
      $MenuP4->set_submenu($SubP4);

      $MenuP4I1 = &new GtkMenuItem(Trans::Translate('Import DBF'));
      $MenuP4I1->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Import DBF'), 'extension_loaded(\'dbase\')', 'OpenDBFFile', 'Dbase support is not enable', '*.dbf');
      
      $MenuP4I2 = &new GtkMenuItem(Trans::Translate('Import CSV'));
      $MenuP4I2->connect_object('activate', array(&$this,'HandlerFile'), Trans::Translate('Import CSV'), true, 'OpenCSVFile', '', '*.csv');

      $SubP4->append($MenuP4I1);
      $SubP4->append($MenuP4I2);
      
      $SubP5 = &new GtkMenu;
      $MenuP5->set_submenu($SubP5);

      $MenuP5I1 = &new GtkMenuItem(Trans::Translate('Help'));
      $MenuP5I1->connect_object('activate', array(&$this,'Help'));
      
      $MenuP5I2 = &new GtkMenuItem(Trans::Translate('About'));
      $MenuP5I2->connect_object('activate', array(&$this,'Info'));

      $SubP5->append($MenuP5I1);
      $SubP5->append($MenuP5I2);      

    $MenuBar->append($MenuP1);
    $MenuBar->append($MenuP2);
    $MenuBar->append($MenuP3);
    $MenuBar->append($MenuP4);
    $MenuBar->append($MenuP5);

    $box = &new GtkHBox(false, 4);
    $Vbox->pack_start($box);

        $gbox = &new GtkVBox(false, 2);
        $box->pack_start($gbox);

        $this->Button(&$this, $this->window, $gbox, 'ClearQuery',    Trans::Translate('Clear Query'),      'images/clear.xpm');
        $this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Open SQL File'),    'images/open.xpm',     array( true,                'OpenSQLFile', 'You Have to build the SQL Query firstly', '*.sql'));
        $this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Save to SQL File'), 'images/save.xpm',     array('$this->ReturnSQL()', 'SaveSQLFile', 'You Have to build the SQL Query firstly', '*.sql'));
        $this->Button(&$this, $this->window, $gbox, 'AgataConfig',   Trans::Translate('Configuration'),    'images/config.xpm');

        $line = new GtkHSeparator;
        $line->set_usize(0,10);
        $gbox->pack_start($line,false, false);

        $this->Button(&$this, $this->window, $gbox, 'QueryOnScreen', Trans::Translate('Execute Query'),    'images/execute.xpm');
        $this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Save to TXT File'), 'images/edit.xpm',     array('$this->ReturnSQL()', 'SaveTXTFile', 'You Have to build the SQL Query firstly', '*.txt'));
        $this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Save to PS File'),  'images/ps.xpm',       array('$this->ReturnSQL()', 'SavePSFile',  'You Have to build the SQL Query firstly', '*.ps'));

        $line = new GtkHSeparator;
        $line->set_usize(0,10);
        $gbox->pack_start($line,false, false);

        $this->Button(&$this, $this->window, $gbox, 'Merge',         Trans::Translate('Merge with Doc'),   'images/merge.xpm',    array('$this->ReturnSQL()', '',            'You Have to build the SQL Query firstly', ''));
	$this->Button(&$this, $this->window, $gbox, 'Label',         Trans::Translate('Label Tool'),       'images/label.xpm',    array('$this->ReturnSQL()', '',            'You Have to build the SQL Query firstly',    ''));
	$this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Create Diagram'),   'images/dia.xpm',      array('($this->Block[\'From\'][1])',       'CreateDia', 'Require Tables, please',        '*.dia'));
        $this->Button(&$this, $this->window, $gbox, 'Graph',         Trans::Translate('Generate Graphic'), 'images/graph.xpm',    array(true, '',                            '' ));

        $line = new GtkHSeparator;
        $line->set_usize(0,10);
        $gbox->pack_start($line,false, false);

	$this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Import DBF'),         'images/dbf.xpm',      array( 'extension_loaded(\'dbase\')',      'OpenDBFFile', 'Dbase support is not enable', '*.dbf'));
	$this->Button(&$this, $this->window, $gbox, 'HandlerFile',   Trans::Translate('Import CSV'),         'images/csv.xpm',      array(true,  'OpenCSVFile', '', '*.csv'));

        $line = new GtkHSeparator;
        $line->set_usize(0,10);
        $gbox->pack_start($line,false, false);
	
	//$this->AgataButton($gbox, 'Help',          Trans::Translate('System Help'),      'images/help.xpm',    array(true, '',             '' ));
	$this->Button(&$this, $this->window, $gbox, 'Info',          Trans::Translate('Some informations about developmnent'), 'images/info.xpm',    array(true, '',       '' ));

    $boxA = &new GtkVBox(true, 1);
    $box->pack_start($boxA);

      $hbox = &new GtkVbox(false, 0);
      $boxA->pack_start($hbox, false, false);

        $this->Tables = &new GtkCombo();
        $this->Tables1 = &new GtkCombo();

        $hbox->pack_start($this->CreateBox($this->Tables, 2, Trans::Translate('Tables')), false, false, 10);
        $ComboList = $this->Tables->list;

        $this->FieldList = &new GtkCList(1, array(Trans::Translate('Field Names')));
        $this->FieldList->connect_object('select-row', array(&$this, 'ChangePage'));
        $hbox->pack_start($this->CreateFieldBox(332, $this->FieldList), false, false, 2);
        $ComboList->connect_object('button_press_event', array(&$this,'LoadFields'), &$this->Tables, &$this->FieldList, &$this->FieldListRows);
	

        $this->Reports = &new GtkCombo();

        $hbox->pack_start($this->CreateBox($this->Reports, 2, Trans::Translate('Saved Queries') . ' (*.sql)'), false, false, 10);
        $ComboList = $this->Reports->list;
        $ComboList->connect_object('button_press_event', array(&$this,'OpenReport'), true);

        $x = $this->GetDirArray();
        if ($x)	
          $this->Reports->set_popdown_strings($x);


    $boxB = &new GtkVBox(false, 0);
    $box->pack_start($boxB);

      $hbox = &new GtkHbox(false, 0);
      $boxB->pack_start($hbox);

    $this->AgataNotebook = new GtkNotebook;
    $this->AgataNotebook->set_tab_pos(GTK_POS_TOP);
    $boxB->pack_start($this->AgataNotebook, true, true, 0);
    $this->AgataNotebook->set_border_width(10);
    $this->AgataNotebook->realize();

    list($this->book_open, $this->book_open_mask) = Gdk::pixmap_create_from_xpm_d($this->AgataNotebook->window, null, $this->LivroFechado);
    list($this->book_closed, $this->book_closed_mask) = Gdk::pixmap_create_from_xpm_d($this->AgataNotebook->window, null, $this->LivroAberto);

    $this->NewPage('1 ' . Trans::Translate('Tables'),      Trans::Translate('Mark Tables to proceed the Selection'));
    $this->NewPage('2 ' . Trans::Translate('Selection'),   Trans::Translate('Type of Selection on Field'));
    $this->NewPage('3 ' . Trans::Translate('Links'),       '< ------- >   ' . Trans::Translate('Link Tables'));
    $this->NewPage('4 ' . Trans::Translate('Constraints'), Trans::Translate('Rules, Constraints of Select'));
    //$this->NewPage(Trans::Translate('Author'),             Trans::Translate('Some informations about developmnent'));
    $this->NewPage('?',                                    Trans::Translate('System Help'));

    $child = &new GtkFrame(Trans::Translate('Click on line to edit the content'));
    $child->set_border_width(5);

    $hbox = &new GtkHbox(false, 0);
    $boxB->pack_start($child, false, false);
    
    $this->MakeScrollWin(&$child);
    
	$_box = &new GtkVBox(false, 1);
        $box->pack_end($_box, false, false);
	
          $falsebox = &new GtkVBox(false, 4);
          $_box->pack_start($falsebox, true, true);

        list($pixmap, $mask) = Gdk::pixmap_create_from_xpm($this->window->window, null, "images/image.xpm");
        $pixmapwid = &new GtkPixmap($pixmap, $mask);
        $_box->pack_end($pixmapwid, false, false);
	
    $this->window->show_all();
  }

  function InicializaVars()
  {
    $this->TableListRows = 0;
    $this->FieldListRows = 0;
    $this->SelectListRows = 0;
  }
  

  function GetDirArray()
  {
    $handle=opendir('.');
    while ($file = readdir($handle))
    {
      if (strstr(strtoupper($file), 'SQL'))
        $aReturn[] = $file;
    }
    closedir($handle);
    if ($aReturn)
      ksort($aReturn);
    
    return $aReturn;
  }




  function EditSelectList()
  {
    $this->SelectList->freeze();
    $selection = $this->SelectList->selection;
    $this->SelectList->thaw();

    $Clause  = $this->SelectList->get_text($selection[0],0);
    $Content = $this->SelectList->get_text($selection[0],1);

    if ($Clause=='Where')
    { $Elements = explode("and", trim($Content)); }
    else
    { $Elements = explode(",", trim($Content)); }

    $this->AList = new Alist(Trans::Translate('List Edition'),
                      array($Clause), $Elements, 400, 200);
    $this->AList->Exibe();

    $buttonc = &new GtkButton(Trans::Translate('Write'));
    $buttonc->connect_object('clicked', array(&$this, 'ReturnEditList'), $Clause);
    $this->AList->vbox->pack_start($buttonc, true, false);
    $buttonc->show();
  }

  function ReturnEditList($Clause)
  {
    $AList = $this->AList;
    $clist = $AList->clist;
    $strings = '';

    if ($Clause=='Where')
    {  $separator  = ' and '; }
    else
    {  $separator  = ', '; }

    $init = false;

    $n =0;
    while ($text = @$clist->get_text($n,0))
    {
      if (($init) && ($text))
        $strings .= $separator;

      if ($text)
        $strings .= $text;

      $init = true;
      $n ++;
    }

    $this->Block[$Clause][1] = $strings;
    $this->LoadBlocks();
    $AList->FechaAlist();
  }
  /***********************************************************/
  /* Funo que cria janela rolante
  /***********************************************************/
  function MakeScrollWin($box)
  {
    $this->SelectNotebook = new GtkNotebook;
    $this->SelectNotebook->show();
    $this->SelectNotebook->set_tab_pos(GTK_POS_RIGHT);
    
    $box->add($this->SelectNotebook);
    $this->SelectNotebook->set_border_width(10);
    $this->SelectNotebook->realize();
    $this->SelectNotebook->show();

    $hbox = &new GtkHBox(false, 0);
    $hbox->set_border_width(2);
    $hbox->show();
    
    $scrolled_win = &new GtkScrolledWindow();
    $scrolled_win->set_border_width(5);
    $scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    $titles = array(Trans::Translate('Block'), Trans::Translate('Content'));

    $this->SelectList = &new GtkCList(2, $titles);
    $this->SelectList->connect_object('select-row', array(&$this, 'EditSelectList'));

    $this->SelectList->set_selection_mode(GTK_SELECTION_EXTENDED);
    $list = &$this->SelectList;

    $scrolled_win->add($list);
    $list->show();

    $hbox->add($scrolled_win);
    $scrolled_win->show();

    $list->set_row_height(18);
    $list->set_usize(-1, 140);

    $list->set_column_width(0, 80);
    $list->set_column_width(1, 10248);

    $this->LoadBlocks(true);
    
    // ----

    $label_box = &new GtkHBox(false, 0);

    $label = &new GtkLabel('1');
    $label_box->pack_start($label, false, true, 0);
    $label_box->show_all();

    $menu_box = &new GtkHBox(false, 0);
    $menu_box->show_all();


    $hbox2 = &new GtkHBox(false, 0);
    $hbox2->set_border_width(2);
    $hbox2->show();

    $this->FreeSelect = &new GtkText();
    $hbox2->pack_start($this->FreeSelect);
    
    $a = gdk::font_load ("-*-courier-medium-r-normal-*-*-148-*-*-*-*-*-*");
    $this->FreeSelect->insert($a, null, null, Trans::Translate('Here you may type your free select') . "\n");

    $this->FreeSelect->set_editable(true);
    $this->FreeSelect->set_usize(364, -1);
    $this->FreeSelect->show();    

    $this->SelectNotebook->append_page_menu($hbox, $label_box, $menu_box);

    $label_box = &new GtkHBox(false, 0);
    $label = &new GtkLabel('2');
    $label_box->pack_start($label, false, true, 0);

    $label_box->show_all();

    $menu_box = &new GtkHBox(false, 0);
    $menu_box->show_all();

    $this->SelectNotebook->append_page_menu($hbox2, $label_box, $menu_box);


  }

  function LoadBlocks($init = false)
  {

    if ($init)
    {
      $this->Block['Select'] = array('Select','');
      $this->Block['From'] = array('From','');
      $this->Block['Where'] = array('Where','');
      $this->Block['Group by'] = array('Group by','');
      $this->Block['Order by'] = array('Order by','');
    }

    $this->SelectListRows = 0;
    $this->SelectList->clear();
    foreach ($this->Block as $Clause)
    {
      $this->SelectList->append($Clause);
      $this->SelectListRows ++;
    }
  }


  /***********************************************************/
  /* Funo que cria a pgina do notebook
  /***********************************************************/
  function NewPage($texto, $texto2)
  {
    $child = &new GtkFrame($texto2);
    $child->set_border_width(5);

    $vbox = &new GtkVBox(false, 0);
    $vbox->set_border_width(2);
    $child->add($vbox);

    $hbox = &new GtkHbox(true, 5);
    $vbox->pack_start($hbox);

    if (substr($texto,0,1)=='1')
    {
      $hbox->pack_start($this->CreateTablePage(), true, true);
    }
    else if (substr($texto,0,1)=='2')
    {
      $hbox->pack_start($this->CreateSelectionPage(), true, true);
    }
    else if (substr($texto,0,1)=='3')
    {
      $hbox->pack_start($this->CreateLinkPage(), false, false, 0);
    }
    else if (substr($texto,0,1)=='4')
    {
      $hbox->pack_start($this->CreateConstraintPage(), false, false, 0);
    }
    else if (substr($texto,0,1)=='?')
    {
      $hbox->pack_start($this->CreateHelpPage(), true, true);
    }

    $label_box = &new GtkHBox(false, 0);
    $pixwid = &new GtkPixmap($this->book_closed, $this->book_closed_mask);
    $label_box->pack_start($pixwid, false, true, 0);
    $pixwid->set_padding(3, 1);

    $label = &new GtkLabel($texto);
    $label_box->pack_start($label, false, true, 0);

    $label_box->show_all();

    $menu_box = &new GtkHBox(false, 0);
    $pixwid = &new GtkPixmap($this->book_closed, $this->book_closed_mask);
    $menu_box->pack_start($pixwid, false, true, 0);
    $pixwid->set_padding(3, 1);

    $label = &new GtkLabel("GtkLabel1a");
    $menu_box->pack_start($label, false, true, 0);

    $menu_box->show_all();
    $child->show_all();

    $this->AgataNotebook->append_page_menu($child, $label_box, $menu_box);
  }

  function CreateTablePage()
  {
    $bbox = &new GtkVBox(false);

    $bbox->set_border_width(5);
    $bbox->show();

    $scrolled_win = &new GtkScrolledWindow();
    $scrolled_win->set_border_width(5);
    $scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    $titles = array(Trans::Translate('Table Name'));

    $this->TableList = &new GtkCList(1, $titles);
    $this->TableList->set_selection_mode(GTK_SELECTION_EXTENDED);
    $list = &$this->TableList;

    $scrolled_win->add($list);
    $list->show();

    $hbox = &new GtkHBox(true, 0);
    $hbox->set_border_width(5);
    $bbox->pack_end($hbox);
    $hbox->show();

    $button = &new GtkButton(Trans::Translate('Require Tables'));
    $button->set_border_width(0);
    $button->connect_object('clicked', array(&$this,'RequireTables'));
    $hbox->pack_start($button, false, true, 0);

    $button = &new GtkButton(Trans::Translate('Clear'));
    $button->set_border_width(0);
    $button->connect_object('clicked', array(&$this,'ClearTables'));
    $hbox->pack_start($button, false, true, 0);

    $bbox->pack_start($scrolled_win);
    $scrolled_win->show();

    $list->set_row_height(18);
    $list->set_usize(-1, 168);

    $conn = new Connection;
    $conn->Open();
    $Tables = $conn->LoadTables();
    $conn->Close();

    if ($Tables)
      foreach ($Tables as $Table)
      {
        $list->append(array($Table));
        $this->AllTables[] = $Table;
        $this->TableListRows ++;
      }

    return $bbox;
  }


  function CreateSelectionPage()
  {
    $bbox = &new GtkHBox();

    $bbox->set_border_width(5);
    $bbox->show();

    $strings1[] = array('Select', 'Select');
    $strings1[] = array('Select', 'Select distinct');
    $strings1[] = array('Order by',  'Ascendant Order');
    $strings1[] = array('Order by',  'Descendant Order');
    $strings1[] = array('Select', 'Clear Select');
    $strings1[] = array('Order by',  'Clear Order');

    $strings2[] = array('Group by', 'Group by Select');
    $strings2[] = array('Select',   'Count');
    $strings2[] = array('Select',   'Sum');
    $strings2[] = array('Select',   'Average');
    $strings2[] = array('Select',   'Minimal');
    $strings2[] = array('Select',   'Maximal');

    $hbox = &new GtkVBox(false, 0);
    $hbox->set_border_width(5);
    $bbox->pack_start($hbox);

    foreach ($strings1 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $hbox->pack_start($button, false, true, 0);
    }
/*
    $frame = &new GtkFrame(Trans::Translate('Type'));
    $frame->set_border_width(5);
    $this->ActualFieldType = &new GtkLabel('');
    $frame->add($this->ActualFieldType);
    
    $hbox->pack_start($frame);*/
    //$label->show();

    $hbox2 = &new GtkVBox(false, 0);
    $hbox2->set_border_width(5);
    $bbox->pack_start($hbox2);

    foreach ($strings2 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->show();
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $hbox2->pack_start($button, false, true, 0);
    }
    /*
    $frame = &new GtkFrame(Trans::Translate('Functions'));
    $frame->set_border_width(5); 
    $hbox2->pack_start($frame);
*/
    return $bbox;
  }


  function CreateLinkPage()
  {
    $bbox = &new GtkHBox(false, 20);

    $bbox->set_border_width(0);

    $hbox = &new GtkVBox();
    $hbox->set_border_width(0);
    $bbox->pack_end($hbox);

    $this->FieldList1 = &new GtkCList(1, array(Trans::Translate('Field Names')));
    $hbox->pack_start($this->CreateFieldBox(100, $this->FieldList1), true, true, 10);

    $vboxL = &new GtkVBox();
    $vboxL->set_border_width(0);

        $vboxL->pack_start($this->CreateBox($this->Tables1, 10, Trans::Translate('Tables')), true, true, 10);
        $ComboList = $this->Tables->list;

        $this->Tables->show();

        $ComboList = $this->Tables1->list;
        $ComboList->connect_object('button_press_event', array(&$this,'LoadFields'), &$this->Tables1, &$this->FieldList1, &$this->FieldList1Rows);

      $child = &new GtkFrame(Trans::Translate('Links'));
      $vboxL->pack_start($child);
      
        $hbox2 = &new GtkHBox();
        $hbox2->set_border_width(0);

          $vboxa = &new GtkVBox();
          $vboxa->set_border_width(0);

          $vboxb = &new GtkVBox();
          $vboxb->set_border_width(0);

      $hbox2->pack_start($vboxa);
      $hbox2->pack_start($vboxb);

    $bbox->pack_start($vboxL);
    $child->add($hbox2);

    $strings1[] = array('Where', ' =  ');
    $strings1[] = array('Where', ' >  ');
    $strings1[] = array('Where', ' <  ');
    $strings1[] = array('Where', 'Clear Where');

    $strings2[] = array('Where', ' >= ');
    $strings2[] = array('Where', ' <= ');
    $strings2[] = array('Where', ' <> ');

    foreach ($strings1 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $vboxa->pack_start($button, false, false, 0);
    }

    foreach ($strings2 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $vboxb->pack_start($button, false, false, 0);
    }
      
    return $bbox;
  }


  function CreateConstraintPage()
  {
    $bbox = &new GtkHBox(false, 20);
    $bbox->set_border_width(0);

    $hbox = &new GtkVBox();
    $hbox->set_border_width(0);
    $bbox->pack_end($hbox);

    $vboxL = &new GtkVBox();
    $vboxL->set_border_width(0);

        $this->Expression  = &new GtkEntry();
        $vboxL->pack_start($this->CreateBox($this->Expression, 10, Trans::Translate('Expression')), true, true, 10);
        $this->Expression->set_usize(260,20);
        $ComboList = $this->Tables->list;

        $this->Tables->show();

      $child = &new GtkFrame(Trans::Translate('Links'));
      $vboxL->pack_end($child);
      $vboxL->show();

        $hbox2 = &new GtkHBox();
        $hbox2->set_border_width(0);

          $vboxa = &new GtkVBox();
          $vboxa->set_border_width(0);

          $vboxb = &new GtkVBox();
          $vboxb->set_border_width(0);

          $vboxc = &new GtkVBox();
          $vboxc->set_border_width(0);

      $hbox2->pack_start($vboxa);
      $hbox2->pack_start($vboxb);
      $hbox2->pack_start($vboxc);

    $bbox->pack_start($vboxL);
    $child->add($hbox2);

    $strings1[] = array('Constraint', ' =  ');
    $strings1[] = array('Constraint', ' >  ');
    $strings1[] = array('Constraint', ' <  ');
    $strings1[] = array('Constraint', 'Clear Where');

    $strings2[] = array('Constraint', ' >= ');
    $strings2[] = array('Constraint', ' <= ');
    $strings2[] = array('Constraint', ' <> ');
    $strings2[] = array('Constraint', ' like ');

    $strings3[] = array('Constraint', ' in ');
    $strings3[] = array('Constraint', ' not in ');
    $strings3[] = array('Constraint', ' is null ');
    $strings3[] = array('Constraint', ' is not null ');

    foreach ($strings1 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $vboxa->pack_start($button, false, false, 0);
    }

    foreach ($strings2 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $vboxb->pack_start($button, false, false, 0);
    }

    foreach ($strings3 as $string)
    {
      $button = &new GtkButton(Trans::Translate($string[1]));
      $button->set_border_width(5);
      $button->connect_object('clicked', array(&$this,'InsertOnBlock'), $string);
      $vboxc->pack_start($button, false, false, 0);
    }

    return $bbox;
  }

  function Info()
  {
    $iwindow = new GtkWindow;
    $iwindow->set_title('Info');
    $iwindow->set_default_size(500, 400);
    $iwindow->set_position(GTK_WIN_POS_CENTER);

    $scrolled_win = &new GtkScrolledWindow();
    $scrolled_win->set_border_width(5);
    $scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    $iwindow->add($scrolled_win);

    $HelpText = &new GtkText();
    $scrolled_win->add($HelpText);
    $scrolled_win->show();

    $strings[] = 'Agata Report 3.0 final';
    $strings[] = '';
    $strings[] = Trans::Translate('IT Department');
    $strings[] = '';
    $strings[] = Trans::Translate('Development by') . " Pablo Dall'Oglio";
    $strings[] = 'pablo@univates.br    -   pablo@php.net';
    $strings[] = '';
    $strings[] = 'UNIVATES - Rio Grande do Sul - Brasil';
    $strings[] = 'http://agata.codigolivre.org.br';
    $strings[] = '';
    $strings[] = Trans::Translate('See also THANKS file');
    
    $fd = fopen('THANKS', "r");
    while (!feof ($fd))
    {
      $buffer = fgets($fd, 500);
      $buffer = ereg_replace("\n", '', $buffer);
      $strings[] = $buffer;
    }
    fclose($fd);

    foreach ($strings as $string)
    {
      $HelpText->insert(null, null, null, "$string\n");
    }
    $HelpText->show();
    $HelpText->set_usize(364, -1);
    
    $iwindow->show();
  }

  function CreateHelpPage()
  {
    $bbox = &new GtkHBox(false, 20);

    $bbox->set_border_width(0);

    $vbox = &new GtkVBox(true, true);
    $vbox->set_border_width(0);
    $bbox->pack_end($vbox, true, true, 10);

    $scrolled_win = &new GtkScrolledWindow();
    $scrolled_win->set_border_width(5);
    $scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    $vbox->add($scrolled_win);

    $HelpText = &new GtkText();
    $scrolled_win->add($HelpText);

    $HelpLines[] = "\n     " . Trans::Translate("First, you must choose the tables you will need (guide 1)  using the 'Require Tables' button. The tables will then be loaded in a ComboBox in your high-left corner of the screen. Then, when you click on any table of this ComboBox, it's fields will be loaded in the list bellow this;") . "\n";
    $HelpLines[] = "     " . Trans::Translate('Then, you may go to (guide 2) and click on the field that you want to select... and click on the function you want to apply on this field;'). "\n";
    $HelpLines[] = "     " . Trans::Translate('Next, go to (guide 3) where you may stablish links among the tables (if you do require more than one table to work). First, select the fields of both tables and link them with an operator(=, >, <...);') . "\n";
    $HelpLines[] = "     " . Trans::Translate('Finnaly (guide 4) you may create constraints to any fields, comparing it (=, >=, like...) with any typed expression. Just click on the field, type the expression and click on the desired operation (=, >=,like...);') . "\n";
    $HelpLines[] = "     " . Trans::Translate('You are now ready to query, generate PostScript or text file and even use your results inside a text document (letter p.e.) once it contains variables understable by Agata;') . "\n";

    foreach($HelpLines as $HelpLine)
      $HelpText->insert(null, null, null, "$HelpLine\n");

    $HelpText->set_usize(364, -1);

    return $bbox;
  }


  function RequireTables()
  {
    $this->TableList->freeze();
    $selection = $this->TableList->selection;
    $strings = null;
    $lista = '';

    foreach ($selection as $SelectionLine)
    {
      $text = $this->TableList->get_text($SelectionLine,0);
      $strings[] = $text;
      $lista .= "$text,";
    }

    if ($strings)
    {
      $MergeTables = array_merge($this->RequiredTables, $strings);
      $this->RequiredTables = $MergeTables;

      $this->Tables->set_popdown_strings($MergeTables);
      $this->Tables1->set_popdown_strings($MergeTables);

      $lista = substr($lista, 0, strlen($lista) -1);
      $this->Block['From'][1] = $this->Block['From'][1] ? $this->Block['From'][1] . ', ' . $lista : $lista;

      $this->LoadBlocks();
    }

    $this->TableList->thaw();
  }

  function ClearTables()
  {
    $this->Tables->set_popdown_strings(array(null));
    $this->FieldList->clear();
    $this->RequiredTables = null;
    $this->Block['From'][1] = '';
    $this->LoadBlocks();
  }


  function CreateFieldBox($altura, &$FieldList)
  {
    $frame = &new GtkFrame(Trans::Translate('Fields of Selected Table'));
    $bbox = &new GtkVBox();
    $frame->add($bbox);

    $bbox->set_border_width(5);
    $bbox->show();

    $scrolled_win = &new GtkScrolledWindow();
    $scrolled_win->set_border_width(5);
    $scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    $list = &$FieldList;
    $FieldList->set_selection_mode(GTK_SELECTION_EXTENDED);

    $scrolled_win->add($list);
    $list->show();

    $bbox->pack_start($scrolled_win);
    $scrolled_win->show();

    $list->set_row_height(18);
    $list->set_usize(-1, $altura);

    $frame->show();
    return $frame;
  }

  function LoadFields($widget, $TableList, $FieldList, $FieldListRows)
  {
    $combo_entry = $TableList->entry;
    $Table = $combo_entry->get_text();

    if ($Table)
    {
      $FieldList->clear();
      $conn = new Connection;
      $conn->Open();
      $Fields = @$conn->LoadFields($Table);
      $conn->Close();

      $FieldListRows = 0;
      if ($Fields)
        foreach ($Fields as $Field)
        {
          $FieldList->append(array($Field));
          $FieldListRows ++;
        }
    }
  }

  function InsertOnBlock($arraystring)
  {
    $index = $arraystring[0];
    $command = trim($arraystring[1]);

    $combo_entry = $this->Tables->entry;
    $Table = $combo_entry->get_text();

    $combo_entry1 = $this->Tables1->entry;
    $Table1 = $combo_entry1->get_text();

    if (($this->FieldListRows==0) && ($command != 'Group by Select'))
    {
       Dialog::Aviso(Trans::Translate('Select field, please'));
       return null;
    }

    $this->FieldList->freeze();
    $this->FieldList1->freeze();

    $selection = $this->FieldList->selection;
    $selection1 = $this->FieldList1->selection;

    $strings = null;
    foreach ($selection as $SelectionLine)
    {
      $strings[] = @$this->FieldList->get_text($SelectionLine,0);
    }

    $strings1 = null;
    foreach ($selection1 as $SelectionLine)
    {
      $strings1[] = @$this->FieldList1->get_text($SelectionLine,0);
    }

    $this->FieldList->thaw();
    $this->FieldList1->thaw();

    if (($command=='Clear Select') || ($command=='Clear Order')  || ($command=='Clear Where'))
    {
      $index = ($index == 'Constraint') ? 'Where' : $index;
      $this->Block[$index][1] = '';
      $this->LoadBlocks();
      return null;
    }

    if (!$strings)
    {
      Dialog::Aviso(Trans::Translate('Select field, please'));
      return null;
    }

    if ($command=='Select')
    {
      foreach ($strings as $string)
      {
        if ($string)
        {
          $this->Block[$index][1] .= ($this->Block[$index][1]) ? ', ' : '';
          $this->Block[$index][1] .= "$Table.$string";
        }
      }
    }
    else if ($command=='Select distinct')
    {
        $this->Block[$index][1] .= ($this->Block[$index][1]) ? ', ' : '';
        $this->Block[$index][1] .= 'distinct ' . "$Table." . $strings[0];
    }
    else if ($command=='Ascendant Order')
    {
      foreach ($strings as $string)
      {
        if ($string)
        {
          $this->Block[$index][1] .= ($this->Block[$index][1]) ? ', ' : '';
          $this->Block[$index][1] .= "$Table.$string asc";
        }
      }
    }
    else if ($command=='Descendant Order')
    {
      foreach ($strings as $string)
      {
        if ($string)
        {
          $this->Block[$index][1] .= ($this->Block[$index][1]) ? ', ' : '';
          $this->Block[$index][1] .= "$Table.$string desc";
        }
      }
    }
    else if (($command=='Count') || ($command=='Sum') || ($command=='Average') || ($command=='Minimal') || ($command=='Maximal'))
    {
      $command = ($command=='Average') ? 'avg' : $command;
      $command = ($command=='Minimal') ? 'min' : $command;
      $command = ($command=='Maximal') ? 'max' : $command;

      $this->Block[$index][1] .= ($this->Block[$index][1]) ? ', ' : '';
      $this->Block[$index][1] .= "$command($Table.$strings[0])";
    }
    else if ($command=='Group by Select')
    {
      $Select = $this->Block['Select'][1];
      $this->Block[$index][1] = $Select;
    }
    else if (($command=='in') || ($command=='not in'))
    {
      $this->in = new in($this->aAgataConfig);
      $this->Button(&$this, $this->in->window, $this->in->vbox2, 'Back', Trans::Translate('Back'), 'images/reload.xpm', array($command,null,null,null));
    }    
    else if (($command=='=') || ($command=='>') || ($command=='<') || ($command=='>=') || ($command=='<=') || ($command=='<>')  || ($command=='like') || ($command=='is null') || ($command=='is not null'))
    {
      if ($index == 'Constraint')
      {
        $Expression = $this->Expression->get_text();
        $index = 'Where';

        if ($Expression || $command == 'is null' || $command == 'is not null')
        {
          $this->Block[$index][1] .= ($this->Block[$index][1]) ? ' and ' : '';
          $this->Block[$index][1] .= "$Table.$strings[0] $command $Expression";
        }
        else
        {
          Dialog::Aviso(Trans::Translate('Please type a expression'));
          return null;
        }
      }
      else
      {
        if ($strings1[0])
        {
          $this->Block[$index][1] .= ($this->Block[$index][1]) ? ' and ' : '';
          $this->Block[$index][1] .= "$Table.$strings[0] $command $Table1.$strings1[0]";
        }
        else
        {
          Dialog::Aviso(Trans::Translate('Select field, please'));
          return null;
        }
      }
    }
    $this->LoadBlocks();
  }
  
  function Back($messge, $command, $tmp1, $tmp2, $tmp3 )
  {
    $combo_entry = $this->Tables->entry;
    $Table = $combo_entry->get_text();
    $selection = $this->FieldList->selection;
    
    $this->in->Close();
    $index = 'Where';
    
    $content = $this->in->content;

    $i_length = $content->get_length();
    $content = $content->get_chars(0, $i_length);
    $content = ereg_replace("\n", '', $content);

    $strings = null;
    foreach ($selection as $SelectionLine)
    {
      $strings[] = @$this->FieldList->get_text($SelectionLine,0);
    }
    
    $this->Block[$index][1] .= ($this->Block[$index][1]) ? ' and ' : '';
    $this->Block[$index][1] .= "$Table.$strings[0] $command ($content)";
    
    $this->LoadBlocks();
  }


  function ReturnSQL()
  {
    $length = $this->FreeSelect->get_length();
    $sql = $this->FreeSelect->get_chars(0, $length);

    if (strtoupper(substr($sql,0,6)) != 'SELECT')
    {
      $sql = '';
      foreach ($this->Block as $Clause)
      {
        if ($Clause[1])
          $sql .= $Clause[0] . ' ' . $Clause[1] . ' ';
      }
    }
    return $sql;
  }


  function CreateReport()
  {
    $this->Query = null;
    $sql = $this->ReturnSQL();

    if ($sql)
    {
      Wait::On();
      $conn = new Connection;
      $conn->Open();

      $query = $conn->CreateQuery($sql);
      $Processed = $query->result; 

      if (!$Processed)
      {
        $conn->Close();
        Wait::Off();
        return false;
      }

      $ColCount = $query->GetColumnCount();

      $Brancos = '                                             ';
      $Brancos .= $Brancos;

      $result = $query->result;
      $line=0;

      $this->Columns = null;
      $this->Maior = null;

      while($row=$result->fetchRow())
      {
	for ($col=1; $col<=$ColCount; $col++)
        {
          $Conteudo           = trim($row[$col-1]);
          $this->Query[$line][$col] = $Conteudo;
          $this->Maior[$col]   = ($this->Maior[$col] > strlen("$Conteudo")) ? $this->Maior[$col] : strlen("$Conteudo");
        }
        $line ++;
      }

      $ColumnNames = $query->GetColumnNames();
      $ColumnTypes = $query->GetColumnTypes();
      $this->ColumnTypes = $ColumnTypes;

      for ( $x=1; $x<=$ColCount; $x++ )
      {
        $Coluna = $ColumnNames[$x -1];
        $QtdeColunas = $this->Maior[$x] - strlen($Coluna);
        $Coluna = $Coluna . (($QtdeColunas>0) ? substr($Brancos, 0, $QtdeColunas *2) : '');
        $this->Columns[] = $Coluna;
        $this->Maior[$x] = strlen($Coluna) +3;
      }

      $conn->Close();
      Wait::Off();
    }
  }

  function OpenReport()
  {
    $this->OpenSQLFile( null );
  }

  function OpenSQLFile( $fs )
  {
    if ($fs)
    {
      $FileName = $fs->get_filename();
      $fs->hide();
    }
    else
    {
      $entry = $this->Reports->entry;
      $FileName = $entry->get_text();
    }
    
    foreach ($this->Block as $key => $Clauses)
    {
      $Clause[] = $key;
    }

    $fd = fopen ("$FileName", "r");
    while (!feof ($fd))
    {
      $buffer = fgets($fd, 5000);
      $buffer = ereg_replace("\n", '', $buffer);
      if ($buffer!='')
      {
        $Linha = explode(":", trim($buffer));
        if (in_array($Linha[0], $Clause))
	{
          $this->Block[$Linha[0]] = array($Linha[0],$Linha[1]);
	}
	else
	{
	  if ($Linha[0] == 'Report')
	    $this->ReportFile = $Linha[1];
	}
      }
    }
    fclose($fd);
    

    $From = $this->Block['From'][1];
    $aFrom = explode(",", $From);

    //aquip
    //$MergeTables = array_merge($this->RequiredTables, $aFrom);
    $this->RequiredTables = $aFrom;

    $this->Tables->set_popdown_strings($aFrom);
    $this->Tables1->set_popdown_strings($aFrom);

    $this->LoadBlocks();
  }

  function SaveSQLFile( $fs)
  {
    $FileName = $fs->get_filename();
    $fd = fopen ("$FileName", "w");
    foreach ($this->Block as $key =>$Clause)
    {
      fwrite($fd,$key . ':' . $Clause[1] . "\n");
    }
    fclose($fd);
    $fs->hide();
    $this->LoadBlocks();
  }

  function QueryOnScreen()
  {
    if (!$this->ReturnSQL())
    {
      Dialog::Aviso(Trans::Translate('You Have to build the SQL Query firstly'));
      return null;
    }

    $this->CreateReport();
    if ($this->Query)
    {
      Wait::On();
      $Grade = new Grid(Trans::Translate('Query Result'), $this->Columns,   700, 400);
      $Grade->AdicionaLinhas($this->Query);
      $Grade->Exibe();
      Wait::Off();
    }
    else
    {
      Dialog::Aviso(Trans::Translate('No Result'));
    }
    
  }

  function SavePSFile($fs)
  {
    $FileName = $fs->get_filename();
    $fs->hide();
    $this->CreateReport();
    
    if ($this->Query)
    {
      include_once 'classes/AgataPs.class';
      $AgataPS = new AgataPS($this->aAgataConfig, $FileName, $this->Query, $this->Maior, $this->Columns, $this->ColumnTypes);
    }
    else
    {
      Dialog::Aviso(Trans::Translate('No Result'));
    }    
  }

  function SaveTXTFile($fs)
  {
    $FileName = $fs->get_filename();
    $fs->hide();
    $this->CreateReport();
    
    if ($this->Query)
    {
      include_once 'classes/AgataTxt.class';
      $AgataTXT = new AgataTXT($this->aAgataConfig, $FileName, $this->Query, $this->Maior, $this->Columns, $this->ColumnTypes);
    }
    else
    {
      Dialog::Aviso(Trans::Translate('No Result'));
    }    
  }

  function CloseFileSelection()
  {
    $this->FileSelection->hide();
  }


  function Merge($message, $Verify, $CallBack, $Message, $Mask)
  {
    eval("\$a = $Verify;");
    if ($a)
    {
      include_once 'classes/Merge.class';

      $length = $this->FreeSelect->get_length();
      $sql = $this->FreeSelect->get_chars(0, $length);
    
      $MyMerge = new Merge($this->Block, $sql);
    }
    else
    {
      Dialog::Aviso(Trans::Translate($Message));
    }
  }
  
  function Label($message, $Verify, $CallBack, $Message, $Mask)
  {
    eval("\$a = $Verify;");
    if ($a)
    {
      include_once 'classes/Label.class';

      $length = $this->FreeSelect->get_length();
      $sql = $this->FreeSelect->get_chars(0, $length);
    
      $MyLabel = new Label($this->Block, $sql);  
    }
    else
    {
      Dialog::Aviso(Trans::Translate($Message));
    }
  }
 
  function Graph($message, $Verify, $CallBack, $Message, $Mask)
  {
    eval("\$a = $Verify;");
    if ($a)
    {
      include_once 'classes/EIS.class';

      $MyEIS = new EIS($this->aAgataConfig);
    }
    else
    {
      Dialog::Aviso(Trans::Translate($Message));
    }
  }
 
  function CreateDia($fs)
  {
    $FileName = $fs->get_filename();
    $fs->hide();
    $aTables = explode(',', $this->Block['From'][1]);
    
    include_once 'classes/Dia.class';
    $MyDia = new Dia($this->aAgataConfig, $FileName, $aTables);      
  }  

  function AgataConfig()
  {
    if (!$this->CheckMyVars)
    {
        $default = $this->aAgataConfig['defaultConfiguration'];
        $aOrientation = array('Portrait', 'Landscape');
	
        $this->aCheckVars[] = array($this->aAgataConfig[$default]['Precision'],   Trans::Translate($this->aDescription['Precision']),  false, null);
        $this->aCheckVars[] = array($this->aAgataConfig[$default]['ThouSep'],     Trans::Translate($this->aDescription['ThouSep']),    false, null);
        $this->aCheckVars[] = array($this->aAgataConfig[$default]['DecSep'],      Trans::Translate($this->aDescription['DecSep']),     false, null);
        $this->aCheckVars[] = array($this->aAgataConfig[$default]['DateFmt'],     Trans::Translate($this->aDescription['DateFmt']),    false, null);
        $this->aCheckVars[] = array($this->aAgataConfig[$default]['DateTimeFmt'], Trans::Translate($this->aDescription['DateTimeFmt']),false, null);
	
	$this->aCheckVars[] = array($this->aAgataConfig[$default]['Orientation'], Trans::Translate($this->aDescription['Orientation']),false, $aOrientation);
	$this->aCheckVars[] = array($this->aAgataConfig[$default]['PsLineLen'],   Trans::Translate($this->aDescription['PsLineLen']),  false, null);

        $this->CheckMyVars = new FormEntry(Trans::Translate('Report Configuration'),
                                        $this->aCheckVars, false, '* ' . Trans::Translate('Loaded from config.php'));
        $this->CheckMyVars->button->connect_object('clicked', array(&$this,'ReturnVars'));
        $this->CheckMyVars->Show();
    }
    else
    {
      $this->CheckMyVars->Show();
    }
  }

  function ReturnVars()
  {
    $aInputEntries = $this->CheckMyVars->InputEntries;
    
    $default = $this->aAgataConfig['defaultConfiguration'];
    $this->aAgataConfig[$default]['Precision']   = $aInputEntries[0]->get_text();
    $this->aAgataConfig[$default]['ThouSep']     = $aInputEntries[1]->get_text();
    $this->aAgataConfig[$default]['DecSep']      = $aInputEntries[2]->get_text();
    $this->aAgataConfig[$default]['DateFmt']     = $aInputEntries[3]->get_text();
    $this->aAgataConfig[$default]['DateTimeFmt'] = $aInputEntries[4]->get_text();
    
    $a = $aInputEntries[5]->entry;
    $this->aAgataConfig[$default]['Orientation']  = $a->get_text();

    $this->aAgataConfig[$default]['PsLineLen']   = $aInputEntries[6]->get_text();

    $this->CheckMyVars->Close(null);
  }
  
  function ClearQuery()
  {
    $this->LoadBlocks(true);
    $this->ClearTables();
  }

  function ChangePage()
  {/*
    $selection = $this->FieldList->selection;
    $field = $this->FieldList->get_text($selection[0],0);
    
    $combo_entry = $this->Tables->entry;
    $Table = $combo_entry->get_text();

    if ($Table)
    {
      $sql = "select $field from $Table limit 1";

      $conn = new Connection;
      $conn->Open();

      $query = $conn->CreateQuery($sql);
      $Processed = $query->result; 

      if (!$Processed)
      {
        $type = '';
      }
      else
      {
        $ColumnTypes = $query->GetColumnTypes();
	$type = $ColumnTypes[0];
      }
      $conn->Close();
    }*/

    //$this->ActualFieldType->set_text($type);
    

    if ($this->AgataNotebook->get_current_page() == 0)
      $this->AgataNotebook->set_page(1);
  }
  
  function OpenDBFFile( $fs )
  {
    if ($fs)
    {
      $FileName = $fs->get_filename();
      $fs->hide();
    }
    else
    {
      $entry = $this->Reports->entry;
      $FileName = $entry->get_text();
    }

    include_once 'classes/AgataDBF.class';
    $AgataDBF = new AgataDBF($this->aAgataConfig, $FileName, $this->AllTables);
  }
  
  function OpenCSVFile( $fs )
  {
    if ($fs)
    {
      $FileName = $fs->get_filename();
      $fs->hide();
    }
    else
    {
      $entry = $this->Reports->entry;
      $FileName = $entry->get_text();
    }

    include_once 'classes/AgataCSV.class';
    $AgataCSV = new AgataCSV($this->aAgataConfig, $FileName, $this->AllTables);
  }
  
  function Help()
  {
    $this->AgataNotebook->set_page(4);
  }
}
?>
