<?
    include_once ("jpgraph/jpgraph.php");
    include_once ("jpgraph/jpgraph_line.php");

    // Create the graph. These two calls are always required
    $graph = new Graph(448,228,"auto");
    $graph->SetScale("textlin");
    
    $i = 0;
    $count = count($Colors);
    foreach($matrix as $key=>$Vetor)
    {
      // Create the linear plot
      $lineplot[$i]=new LinePlot($Vetor);
      $lineplot[$i]->mark->SetType(MARK_CIRCLE);
      $lineplot[$i]->SetLegend($key);
      $lineplot[$i]->SetColor($Colors);
      $lineplot[$i]->SetWeight(2);        
      
      // Add the plot to the graph
      $graph->Add($lineplot[$i]);
      
      $i++;
      if ($i==$count)
        $i = 0;
    }
    
    //$graph->SetLegends(array("Jan","Feb","Mar","Apr","May","Jun","Jul"));

    $graph->img->SetMargin(40,100,20,40);
    $graph->title->Set($title);
    $graph->title->SetColor($FontColor);
    
    $graph->xaxis->title->Set($xtitle);
    $graph->yaxis->title->Set($ytitle);
    $graph->xaxis->title->SetColor($FontColor);
    $graph->yaxis->title->SetColor($FontColor);

    $graph->title->SetFont(FF_FONT1,FS_BOLD);
    $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
    $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
    //$graph->xaxis->SetTickLabels($array_tick_);
 
    $graph->xaxis->SetColor($BorderColor);
    $graph->yaxis->SetColor($BorderColor);
    $graph->xaxis->SetWeight(2);
    $graph->yaxis->SetWeight(2);
    $graph->SetShadow();

    // Display the graph
    $graph->Stroke('lines.png');
?>
